#include "nlp_time.h"
#include <iostream>
#include <assert.h>
using namespace std;


//													
String Time::CurrentTime (void)
{
	String sTime;

	timeval tv;
	timerclear (&tv);
	if (0 != gettimeofday (&tv, NULL))
		return sTime;	

	sTime << tv.tv_sec << "s, " << tv.tv_usec << "us";
	return sTime;
}



//													
void Time::StartTimer (void)
{
	timerclear (&tv_Start);
	timerclear (&tv_Elapsed);
	if (0 != gettimeofday (&tv_Start, NULL))
		cerr << "[ERROR]  Call to gettimeofday failed in Time::StartTimer" << endl;
}


//													
#define MILLION		1000000
void Time::StopTimer (void)
{
	timeval tvNow;
	timerclear (&tvNow);
	if (0 != gettimeofday (&tvNow, NULL))
	{
		cerr << "[ERROR]  Call to gettimeofday failed in Time::StartTimer" << endl;
		return;
	}

	timeval tvDiff;
	tvDiff.tv_sec = tvNow.tv_sec - tv_Start.tv_sec;
	tvDiff.tv_usec = tvNow.tv_usec - tv_Start.tv_usec;
	if (tvDiff.tv_usec < 0)
	{
		tvDiff.tv_usec += MILLION;
		-- tvDiff.tv_sec;
	}

	tv_Elapsed.tv_sec += tvDiff.tv_sec;
	tv_Elapsed.tv_usec += tvDiff.tv_usec;
	if (tv_Elapsed.tv_usec > MILLION)
	{
		tv_Elapsed.tv_usec -= MILLION;
		++ tv_Elapsed.tv_sec;
	}
}


//													
timeval Time::DiffToNow (void)
{
	timeval tvDiff;
	timerclear (&tvDiff);

	timeval tvNow;
	timerclear (&tvNow);
	if (0 != gettimeofday (&tvNow, NULL))
	{
		cerr << "[ERROR]  Call to gettimeofday failed in Time::StartTimer" << endl;
		return tvDiff;
	}

	tvDiff.tv_sec = tvNow.tv_sec - tv_Start.tv_sec;
	tvDiff.tv_usec = tvNow.tv_usec - tv_Start.tv_usec;
	if (tvDiff.tv_usec < 0)
	{
		tvDiff.tv_usec += MILLION;
		-- tvDiff.tv_sec;
	}

	return tvDiff;
}


//													
time_t Time::SecondsToNow (void)
{
	timeval tvDiff = DiffToNow ();
	return tvDiff.tv_sec;
}


//													
time_t Time::MinutesToNow (void)
{
	timeval tvDiff = DiffToNow ();
	return tvDiff.tv_sec / 60;
}


//													
String Time::sTimeToNow (void)
{
	timeval tvDiff = DiffToNow ();
	String sDiff;
	sDiff << tvDiff.tv_sec << "+s, " << tvDiff.tv_usec << "+us";
	return sDiff;
}


//													
String Time::sStartStopTime (void)
{
	String sElapsed;
	sElapsed << tv_Elapsed.tv_sec << ">s, " << tv_Elapsed.tv_usec << ">us";
	return sElapsed;
}


//													
String Time::sDateTime (void)
{
	time_t t = time (NULL);
	char zTime [201];
	#ifndef NDEBUG
	size_t iTimeLen = strftime (zTime, 200, "%Y-%m-%d_%H-%M-%S", localtime (&t));
	assert (iTimeLen < 200);
	#else
	strftime (zTime, 200, "%Y-%m-%d_%H-%M-%S", localtime (&t));
	#endif

	String sTime (zTime);
	return sTime;
}


//													
String Time::sDateTimeMicroSec (void)
{
	String sTime;

	timeval tv;
	timerclear (&tv);
	if (0 != gettimeofday (&tv, NULL))
	{
		cerr << "[ERROR]  Call to gettimeofday failed in Time::sDateTimeMicroSec" << endl;
		return sTime;
	}

	char zTime [201];
	#ifndef NDEBUG
	size_t iTimeLen = strftime (zTime, 200, "%Y-%m-%d_%H-%M-%S", localtime (&tv.tv_sec));
	assert (iTimeLen < 200);
	#else
	strftime (zTime, 200, "%Y-%m-%d_%H-%M-%S", localtime (&tv.tv_sec));
	#endif

	sTime << zTime << '-' << tv.tv_usec;
	return sTime;
}


